<?php
/*
Plugin Name: WP Comment Notifier For All
Description: Notify all Wordpress users (and not only the admin) on comment approval.
Version: 1.0
Author: Fayal Tirich
*/

$cnfa_from_tpl = "Name <ilove@gmail.com>";

$cnfa_subject_tpl = "[BLOG_NAME] - [COMMENT_AUTHOR] just published a new comment for : [TITLE]";

$cnfa_body_tpl = <<<EOD
<center>[LOGO]http://www.example.org/logo.png[/LOGO]</center><br />
[COMMENT_AUTHOR] just commented the post:<br />
<h3>[TITLE_LINK]</h3>
Good reading !<br />
EOD;

$cnfa_options_msg = '';

function cnfa_get_users () {
    $blog_users = array();
    global $wpdb;
    $users = $wpdb->get_results("SELECT ID, user_login, display_name, user_email  FROM $wpdb->users");
    foreach($users as $user) {
        $object = new stdClass();
        $object->ID = $user->ID;
        $object->user_login = $user->user_login;
        $object->display_name = $user->display_name;
        $object->user_email = $user->user_email;
        $blog_users[$user->ID]=$object;
    }
    return $blog_users;
}

if ( isset($_POST['cnfa_submit']) ) {
        update_option('fay-comment-notifier-for-all_from-tpl', stripslashes_deep(trim($_POST['cnfa_from'])));
        update_option('fay-comment-notifier-for-all_subject-tpl', stripslashes_deep(trim($_POST['cnfa_subject'])));
        update_option('fay-comment-notifier-for-all_body-tpl', stripslashes_deep(trim($_POST['cnfa_body'])));
        $cnfa_options_msg = '<span style="color:green">'.__('Options updated').'</span><br />';
}

$cnfa_from = get_option('fay-comment-notifier-for-all_from-tpl');
if (!isset($cnfa_from)  || empty($cnfa_from)) {
        $cnfa_from = $cnfa_from_tpl ;
}

$cnfa_subject = get_option('fay-comment-notifier-for-all_subject-tpl');
if (!isset($cnfa_subject)  || empty($cnfa_subject)) {
        $cnfa_subject = $cnfa_subject_tpl ;
}

$cnfa_body = get_option('fay-comment-notifier-for-all_body-tpl');
if (!isset($cnfa_body)  || empty($cnfa_body)) {
    $cnfa_body = $cnfa_body_tpl ;
}

//for blog users's comments
function cnfa_comment_post($comment_ID) {
    $process = 0;
    $options =  get_option('fay-comment-notifier-for-all_notified-comments');
    if (!is_array($options)) {
        $options = array ();
        update_option('fay-comment-notifier-for-all_notified-comments', $options);
        $process = 1;
    } else {
        if (in_array($comment_ID, $options)) {
            $process = 0;
        } else {
            $process = 1;
        }
    }
    if ($process==1){
        $comment = get_comment($comment_ID);
        if ($comment->user_id != 0) {
            $process = 1;
        }else {
            $process = 0;
        }
    }
    if ($process==1)
    {
        cnfa_notification_email(&$comment, &$options);
    }
    return $comment_ID;
}

//when changing a comment status (for others)
function cnfa_set_comment_status($comment_ID, $status) {
    if ($status=='approve') {
        $comment = get_comment($comment_ID);
        $process = 0;
        $options =  get_option('fay-comment-notifier-for-all_notified-comments');
        if (!is_array($options)) {
            $options = array ();
            update_option('fay-comment-notifier-for-all_notified-comments', $options);
            $process = 1;
        } else {
            if (in_array($comment_ID, $options)) {
                $process = 0;
            } else {
                $process = 1;
            }
        }
        if ($process==1)
        {
            cnfa_notification_email(&$comment, &$options);
        }
    }
    return $comment_ID;
}

function cnfa_notification_email(&$comment, &$options){
    global $cnfa_from, $cnfa_subject, $cnfa_body;
    $post = get_post($comment->comment_post_ID);

    global $wpdb;
    $users = $wpdb->get_results("SELECT ID, user_email FROM $wpdb->users");
    $emails = '';
    foreach($users as $user) {
        if (get_usermeta($user->ID,'cnfa_exclude')!='true') {
            $emails = $user->user_email.', '.$emails ;
        }
    }

    $cnfa_subject = str_replace('[COMMENT_AUTHOR]', htmlspecialchars_decode($comment->comment_author), $cnfa_subject);
    $cnfa_subject = str_replace('[BLOG_NAME]',html_entity_decode(get_bloginfo('name'), ENT_QUOTES), $cnfa_subject);
    $cnfa_subject = str_replace('[TITLE]',  htmlspecialchars_decode($post->post_title), $cnfa_subject);

    $pattern = '/(\[LOGO\])(.*)(\[\/LOGO\])/';
    $replacement = '<img src="${2}" alt="'. htmlspecialchars_decode(get_bloginfo('name')).'"/>';
    $cnfa_body = preg_replace($pattern, $replacement, $cnfa_body);

    $cnfa_body = str_replace('[COMMENT_AUTHOR]', htmlspecialchars_decode($comment->comment_author), $cnfa_body);

    $link = '<a style="color: #2D83D5" href="'.get_permalink($comment->comment_post_ID).'#comment-'.$comment->comment_ID.'">'.$post->post_title.'</a>';
    $cnfa_body = str_replace('[TITLE_LINK]', $link, $cnfa_body);

    $mailTo = "";

    $headers = "From: $cnfa_from\n";
    $headers .= "Bcc: $emails\n";
    $headers .= "MIME-Version: 1.0\n";
    $rand = md5(time());
    $mime_boundary = "----devoteam----".$rand;
    $headers .= "Content-Type: multipart/alternative; boundary=\"$mime_boundary\"\n";

    $message .= "--$mime_boundary\n";
    $message .= "Content-Type: text/html; charset=UTF-8\n";
    $message .= "Content-Transfer-Encoding: 8bit\n\n";
    $message .= "<html>\n";
    $message .= "<body style=\"font-family:Verdana, Verdana, Geneva, sans-serif; font-size:12px; color:#666666;\">\n";
    $message .= $cnfa_body;
    $message .= "\n\n";
    $message .= "</body>\n";
    $message .= "</html>\n";
    $message .= "--$mime_boundary--\n\n";
    if (mail($mailTo, $cnfa_subject, $message, $headers)){
        $options[] = $comment->comment_ID;
        sort($options);
        update_option('fay-comment-notifier-for-all_notified-comments', $options);
    }
}

// Options page
function cnfa_options() {
    global $cnfa_from, $cnfa_from_tpl, $cnfa_subject, $cnfa_subject_tpl, $cnfa_body, $cnfa_body_tpl, $cnfa_options_msg ;
    if ( isset($_POST['cnfa_exclude_submit']) ) {
        $users_to_exclude_array = array();
        if(isset($_POST['cnfa_excluded_users'])) {
            $users_to_exclude_array = $_POST['cnfa_excluded_users'];
        }
        $users = cnfa_get_users();
        $log = '';
        foreach($users as $user) {
            if (in_array($user->ID, $users_to_exclude_array)) {
                if (get_usermeta($user->ID,'cnfa_exclude')!='true'){
                    update_usermeta($user->ID,'cnfa_exclude','true');
                    $log = $log .'<span style="color:green">'.$user->display_name.' excluded</span><br />';
                }
            } else {
                if (get_usermeta($user->ID,'cnfa_exclude')!='false'){
                    update_usermeta($user->ID,'cnfa_exclude','false');
                    $log = $log .'<span style="color:green">'.$user->display_name.' will be notified</span><br />';
                }
            }
        }
        if ($log!=''){
            $cnfa_options_msg = $log;
        }
    }
    if(!empty($cnfa_options_msg)) {
?>
    <!-- Last Action --><div id="message" class="updated fade"><p><?php echo $cnfa_options_msg; ?></p></div>
<?php
}
?>
<div class="wrap">
    <?php screen_icon(); ?>
    <h2>Comment Notifier For All</h2>
    <br />
    <form method="post" action="">
        <div>
            <div>
                <label for="cnfa_from"><strong>Email "From" Template</strong></label>
                <br />
                <input type="text" size="150" id="cnfa_from" name="cnfa_from" value="<?php echo $cnfa_from; ?>" />
                <p>
                    Default "From" Template:<br />
                    <?php
                        $temp = $cnfa_from_tpl ;
                        $temp = str_replace("<","&lt;",$temp);
                        $temp = str_replace(">","&gt;",$temp);
                        echo nl2br($temp);
                    ?>
                </p>
            </div>
            <div>
                <label for="cnfa_subject"><strong>Email "Subject" Template</strong></label>
                <br />
                <input type="text" size="150" id="cnfa_subject" name="cnfa_subject" value="<?php echo $cnfa_subject; ?>" />
                <p>
                    Default "Subject" Template:<br />
                    <?php echo $cnfa_subject_tpl; ?>
                </p>
            </div>
            <div>
                <label for="cnfa_body"><strong>Email "Body" Template</strong></label>
                <br />
                <textarea style="width: 90%; font-size: 12px;" rows="8" cols="60" id="cnfa_body" name="cnfa_body"><?php echo $cnfa_body; ?></textarea>
                <p>
                    Default "Body" Template:<br />
                    <?php
                        $temp = $cnfa_body_tpl ;
                        $temp = str_replace("<","&lt;",$temp);
                        $temp = str_replace(">","&gt;",$temp);
                        echo nl2br($temp);
                    ?>
                </p>
            </div>
            <p class="submit">
                <input class="button-primary" type="submit" name="cnfa_submit" class="button" value="<?php _e('Save Changes'); ?>" />
            </p>
        </div>
    </form>
    <br />
    <h2>Exclude users</h2>
    <form method="post" action="">
            <table class="widefat fixed" cellspacing="0">
            <thead>
            <tr class="thead">
                <th id="cb" class="manage-column column-cb column-exclude" style="" scope="col">
                    <?php echo __('Exclude'); ?>?
                </th>
                <th id="username" class="manage-column column-username" style="" scope="col">
                   <?php echo __('Username'); ?>
                </th>
                <th id="email" class="manage-column column-email" style="" scope="col">
                    <?php echo __('Email'); ?>
                </th>
            </tr>
            </thead>

            <tfoot>
            <tr class="thead">
                <th id="cb" class="manage-column column-cb column-exclude" style="" scope="col">
                    <?php echo __('Exclude'); ?>?
                </th>
                <th id="username" class="manage-column column-username" style="" scope="col">
                   <?php echo __('Username'); ?>
                </th>
                <th id="email" class="manage-column column-email" style="" scope="col">
                    <?php echo __('Email'); ?>
                </th>
            </tr>
            </tfoot>

            <tbody id="users" class="list:user user-list">
            <?php
            $style = '';
            $users = pnfa_get_users();
            foreach($users as $user) {
                $is_checked = false ;
                if (get_usermeta($user->ID,'cnfa_exclude')=='true') {
                    $is_checked = true;
                }
                $style = ( ' class="alternate"' == $style ) ? '' : ' class="alternate"';
                ?>
                <tr id='user-<?php echo $user->ID; ?>' <?php echo $style; ?> <?php echo ($is_checked)?'style="background-color: rgb(255, 153, 153);"':''; ?>>
                <th scope='row' class='check-column'><input type='checkbox'  name='cnfa_excluded_users[]' id='user_<?php echo $user->ID; ?>' <?php echo ($is_checked)?"checked":""; ?>  value='<?php echo $user->ID; ?>' /></th>
                <td><?php echo $user->user_login; ?></td>
                <td><?php echo $user->user_email; ?></td>
                </tr>
                <?php
            }
            ?>
            </tbody>
            </table>
            <p class="submit">
                <input class="button-primary" type="submit" name="cnfa_exclude_submit" class="button" value="<?php _e('Save Changes'); ?>" />
            </p>
        </form>
</div>
<?php
}

function cnfa_user_options() {
    $text = '';
    global $user_ID;
    get_currentuserinfo();
    if ( isset($_POST['cnfa_user_submit']) ) {
            if(isset($_POST['cnfa_user_active']) && $_POST['cnfa_user_active']=='true') {
                if (get_usermeta($user_ID,'cnfa_exclude')!='true'){
                    update_usermeta($user_ID,'cnfa_exclude','true');
                }
            } else {
                if (get_usermeta($user_ID,'cnfa_exclude')!='false'){
                    update_usermeta($user_ID,'cnfa_exclude','false');
                }
            }
            $text = '<span style="color:green">'.__('Option updated').'</span><br />';
    }
    if(!empty($text)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$text.'</p></div>'; }
    ?>
    <div class="wrap">
    <?php screen_icon(); ?>
    <h2>Comment Notifier</h2>
    <br /><br />
    <form method="post" action="">
        <table class="widefat">
            <thead>
                <tr>
                    <th>Disable new comments notification</th>
                </tr>
            </thead>
            <tbody>
            <tr>
                <td>
                    <input type="checkbox" name="cnfa_user_active" value="true" <?php if(get_usermeta($user_ID,'cnfa_exclude')=='true') echo ' checked="checked"'; ?> />&nbsp;<?php _e('Check to disable further notifications'); ?>
                    <p class="submit">
                            <input class="button-primary" type="submit" name="cnfa_user_submit" class="button" value="<?php _e('Save Changes'); ?>" />
                    </p>
                </td>
            </tr>
            </tbody>
        </table>
    </form>
    </div>
<?php
}

function cnfa_menu() {
    if (function_exists('add_options_page')) {
        if( current_user_can('manage_options') ) {
            add_options_page(__('Comment Notifier'), __('Comment Notifier'), 'manage_options', __FILE__, cnfa_options) ;
        }
    }
    if (function_exists('add_submenu_page')) {
        add_submenu_page('users.php', __('Comment Notifier'), __('Comment Notifier'), 'read', __FILE__, cnfa_user_options);
     }
}

add_action('admin_menu', 'cnfa_menu');
add_action('wp_set_comment_status', 'cnfa_set_comment_status',10,2);
add_action('comment_post', 'cnfa_comment_post');
?>